<?php

/**
 * Viper2 Framework
 *
 * @author fish <fish@archa.cz>
 * @package Viper2
 * @version 0.1
 *
 */
/**
 * User administration
 * @package Useradmin
 * @author fish <fish@archa.cz>
 * @version 0.1
 *
 *
 */

class Useradmin extends Viper2Plugin {
  /**
  * variable $cfgPageCount
  * @static integer pocet zaznamu na strance
  */
  protected $cfgPageCount = 15;

  /**
  * variable $cfgSearchForm
  * @static array - definice formulare pro vyhledavani v profilech
  */
  protected $cfgSearchForm = array(
  'id_user' => array( 'type'    => 'text',
             'db_type' => 'int',
             'label'   => 'ID',
             'size'    => 10,
             'max'     => 10,
      ),
  'name'=> array('type'    => 'text',
             'db_type' => 'text',
             'label'   => 'Jméno',
             'size'    => 20,
             'max'     => 40,
      ),
  'login'=> array('type'    => 'text',
             'db_type' => 'text',
             'label'   => 'Login',
             'size'    => 20,
             'max'     => 40,
      ),
  'mail'=> array('type'    => 'text',
             'db_type' => 'text',
             'label'   => 'E-mail',
             'size'    => 20,
             'max'     => 40,
      ),
  'id_grp'=> array('type'    => 'list',
             'db_type' => 'int',
             'label'   => 'Skupina',
             'value_func'=>'getValidGroups',
             // pozor, tady je specialni mod joinovani kvuli podpore vicero skupin pro uzivatele
      ),
  );
  /**
  * variable $cfgListAttribsDisplay
  * @static array - pole vlastnosti uzivatele jehoz klice jsou nazvy sloupcu databaze a data jsou jejich zobrazovana jmena
  */
  protected $cfgListAttribsDisplay = array('id_user'=>'ID', 'name'=>'Jméno', 'login'=>'Login', 'mail'=>'E-mail');
  /**
  * variable $cfgGroupListAttribsDisplay
  * @static array - pole vlastnosti skupin jehoz klice jsou nazvy sloupcu databaze a data jsou jejich zobrazovana jmena
  */
  protected $cfgGroupListAttribsDisplay = array('gid'=>'ID', 'name'=>'Jméno');
  /**
  * variable $cfgUserTableStructure
  * @static array - klice nazvy sloupcu db, data jsou pole s definici viz vstupni pole fform
  */
  protected $cfgUserTableStructure = array(
  'id_grp'=> array('type'    => 'list',
             'label'   => 'Skupina',
             'value_func'=>'getValidGroups',
             'no_empty' => 1,
      ),
  'fname'=> array('type'    => 'text',
             'label'   => 'Jméno',
             'size'    => 20,
             'max'     => 40,
      ),
  'lname'=> array('type'    => 'text',
             'label'   => 'Příjmení',
             'size'    => 20,
             'max'     => 40,
      ),
  'tel'=> array('type'    => 'text',
             'label'   => 'Telefon',
             'size'    => 20,
             'max'     => 20,
             'match'   => '/(^\+?[\d\s]{5,19}$)|^\s*$/',
      ),
  'mobil'=> array('type'    => 'text',
             'label'   => 'Mobil',
             'size'    => 20,
             'max'     => 20,
             'match'   => '/(^\+?[\d\s]{5,19}$)|^\s*$/',
      ),
  'mail'=> array('type'    => 'text',
             'label'   => 'E-mail',
             'size'    => 20,
             'max'     => 40,
             /*'match'   => '#ValidateMail',*/
      ),
  'address'=> array('type'    => 'text',
              'label'   => 'Ulice',
              'size'    => 20,
              'max'     => 40,
      ),
  'city'=> array('type'    => 'text',
              'label'   => 'Město',
              'size'    => 20,
              'max'     => 20,
      ),
  'zip'=> array('type'    => 'text',
              'label'   => 'PSČ',
              'size'    => 20,
              'max'     => 20,
      ),
  'details'=> array('type'    => 'area',
              'label'   => 'Popis',
      ),
  'login'=> array('type'    => 'text',
              'label'   => 'Login',
              'size'    => 20,
              'max'     => 40,
              'req'     => 1,
      ),
  'pwd'  => array('type'    => 'password',
              'label'   => 'Heslo',
              'size'    => 15,
              'max'     => 60,
      ),
  );
  /**
  * variable $cfgGroupTableStructure
  * @static array - klice nazvy sloupcu db, data jsou pole s definici viz vstupni pole fform
  */
  protected $cfgGroupTableStructure = array(
  'name' => array( 'type' => 'text',
                'label'=> 'Název skupiny',
                'size' => 20,
                'max'  => 30,
      ),
  );
  
  
  /**
  * variable $userClassCache
  * @protected static array - cache parametru trid uzivatele
  */
  protected $userClassCache = array();
  /**
  * variable $fullUserTableStructure
  * @protected static array - cache kompletni struktury formulare pro editaci dat o uzivateli
  */
  protected $fullUserFormStructure = array();
  /**
  * variable $superadminGrpId
  * @static int - id skupiny majici plna prava na editaci
  */
  protected $superadminGrpId = 1;
  /**
  * varibale $_isSuperAdmin
  * @protected @static boolean - is logged user superadmin?
  */
  protected $_isSuperAdmin;
  /**
  * varibale $_isAdmin
  * @protected @static boolean - je prihlaseny uzivatel adminem alespon nejake skupiny
  */
  protected $_isAdmin;
  
  function __construct() {
    $this->pluginName = "Useradmin";
    $this->pluginUri = "/sprava-uzivatelu/";
    $this->tplPath = "Useradmin/";
    $this->cssLink="/css/useradmin/useradmin.css";
  }
   
  // actions
  
  /**
  * @mask: /
  * @mask: /index.htm
  * @mask: /index_s(?<pageStart>\d+).htm
  */
  function actionDefault($params) {
  }
  
  function actionUser_Add($params) {
    $this->userSaveOrEdit("add");
  }

  /**
  * @mask: /user/(?<userId>\d+)/edit.htm
  * @mask: /user/(?<userId>\d+)-(?<userName>[^/]+)/edit.htm
  */
  function actionUser_Edit($params) {
    $this->userSaveOrEdit("edit");
  }

  /**
  * @mask: /user/(?<userId>\d+)/rights.htm
  * @mask: /user/(?<userId>\d+)-(?<userName>[^/]+)/rights.htm
  */
  function actionUser_Rights($params) {
    if (!empty($_GET)) {
      // zmena nejakeho prava
      if (!empty($_GET['id_act']) && is_numeric($_GET['id_act']) && array_key_exists('new', $_GET) && in_array($_GET['new'], array('1', '0', 'null'))) {
        // kontrola, jestli dany uzivatel muze menit prava pro tohoto uzivatele
        if (!$this->canEditUserRights(Viper2::getParam("userId"))) {
          v2("Msgbox", "send", _('Na editaci prav tohoto uživatele nemáte dostatečná oprávnění').'.');
          return;
        }
        if (!$this->canEditRight($_GET['id_act']*1)) {
          v2("Msgbox", "send", _('Na editaci tohoto práva nemáte dostatečná oprávnění'.'.'));
          return;
        }
        $done = false;
        if ($_GET['new'] == 'null') {
          $query = 'DELETE FROM user_actions WHERE `id_act`='.$this->dbh->quote($_GET['id_act'], 'integer').' AND `id_user`='.$this->dbh->quote(Viper2::getParam("userId"),'integer');
        } else {
          $query = 'INSERT IGNORE INTO user_actions (`id_user`,`id_act`,`permission`)'.
            ' VALUES ('.$this->dbh->quote(Viper2::getParam("userId"),'integer').', '.$this->dbh->quote($_GET['id_act'], 'integer').','.$this->dbh->quote($_GET['new'], 'integer').')';
          if (PEAR::isError($affected = $this->dbh->exec($query))) {
            v2("Msgbox", "send", _('Nepodařilo se nastavit novou hodnotu práva').'. '._('Zkuste, prosím, akci zopakovat').'.');
            return;
          }
          if (!$affected) {
            // nevlozili jsme, radek jiz existuje - pustime update
            $query = 'UPDATE user_actions SET'.
                ' `permission`='.$this->dbh->quote($_GET['new'],'integer').
              ' WHERE `id_user`='.$this->dbh->quote(Viper2::getParam("userId"),'integer').
                ' AND `id_act`='.$this->dbh->quote($_GET['id_act'],'integer');
          } else {
            $done = true;
          }
        }
        if ($done || !PEAR::isError($this->dbh->query($query))) {
          v2("Msgbox", "sendOk", _('Právo bylo nastaveno').'.');
        } else {
          v2("Msgbox", "send", _('Nepodařilo se nastavit novou hodnotu práva').'. '._('Zkuste, prosím, akci zopakovat').'.');
        }
        unset($_GET['id_act']);
        unset($_GET['new']);
        viper2::$router->reloadPage(null, array_keys($_GET));
      }
    }
  }

  /**
  * @mask: /user/(?<userId>\d+)/delete.htm
  * @mask: /user/(?<userId>\d+)-(?<userName>[^/]+)/delete.htm
  */
  function actionUser_Delete($params) {
    // k mazani uzivatele musi mit tento uzivatel nastavenou hlavni skupinu na nejakou mnou editovatelnou skupinu
    if (!$this->_isSuperAdmin && !$this->_isAdmin) {
      v2("Msgbox", "add", _('Na smazání tohoto uživatele nemáte dostatečná oprávnění').'.');
      return;
    }
    if (!$this->_isSuperAdmin) {
      $User = new flogin_user($this->dbh, Viper2::getParam("userId"));
      if (!$this->isAdmin($User->id_grp)) {
        /** @todo: spravne kontrolovat, ze jsem administratorem vsech skupin, ve kterych dany uzivatel je */
        v2("Msgbox", "add", _('Na smazání tohoto uživatele nemáte dostatečná oprávnění').'.');
        return;
      }
    }
    // mam pravo na smazani, tak mazeme
    if ($this->deleteUser(Viper2::getParam("userId"))) {
      v2("Msgbox", "sendOk", _('Uživatel byl smazán').'.');
      Viper2::$router->redirectTo("Useradmin::default");
    } else {
      v2("Msgbox", "send", _('Proces mazání uživatele nebyl dokončen').'. '._('Zkuste, prosím, akci zopakovat').'.');
      Viper2::$router->redirectTo("Useradmin::default");
    }
  }
 
  function actionGroup_Add($params) {
    $this->groupSaveOrEdit("add");
  }

  /**
  * @mask: /group/(?<groupId>\d+)/edit.htm
  * @mask: /group/(?<groupId>\d+)-(?<groupName>[^/]+)/edit.htm
  */
  function actionGroup_Edit($params) {
    $this->groupSaveOrEdit("edit");
  }

  /**
  * @mask: /group/(?<groupId>\d+)/rights.htm
  * @mask: /group/(?<groupId>\d+)-(?<groupName>[^/]+)/rights.htm
  */
  function actionGroup_Rights($params) {
    if (!empty($_GET)) {
      // kontrola, jestli dany uzivatel muze editovat skupiny
      if (Viper2::getVar("logged")!==TRUE) {
        v2("Msgbox", "add", _('Pro editaci práv skupin se musíte přihlásit').'.');
        return;
      }
      if (!$this->_isSuperAdmin) {
        v2("Msgbox", "add", _('Na editaci práv skupin nemáte dostatečná oprávnění').'.');
        return;
      }
      if (!empty($_GET['id_act']) && is_numeric($_GET['id_act']) && array_key_exists('new', $_GET) && in_array($_GET['new'], array('1', '0'))) {
        if ($_GET['new'] == 0) {
          $query = 'DELETE FROM group_actions WHERE id_act='.$this->dbh->quote($_GET['id_act']).' AND id_grp='.$this->dbh->quote(Viper2::getParam("groupId"));
        } else {
          $query = 'INSERT IGNORE INTO group_actions (`id_act`,`id_grp`) VALUES ('.$this->dbh->quote($_GET['id_act']).','.$this->dbh->quote(Viper2::getParam("groupId"), 'integer').')';
        }
        if (PEAR::isError($this->dbh->query($query))) {
          v2("Msgbox", "add", _('Nastavení práva se nezdařilo').'. '._('Zkuste, prosím, akci zopakovat').'.');
          return;
        } else {
          v2("Msgbox", "add", _('Právo bylo nastaveno').'.');
          return;
        }
      }
      if (!empty($_GET['id_act']) && is_numeric($_GET['id_act']) && array_key_exists('viditelnost', $_GET) && in_array($_GET['viditelnost'], array('1', '0'))) {
        if ($_GET['viditelnost'] == 0) {
          $query = 'DELETE FROM group_visible_actions WHERE id_act='.$this->dbh->quote($_GET['id_act']).' AND id_grp='.$this->dbh->quote(Viper2::getParam("groupId"));
        } else {
          $query = 'INSERT IGNORE INTO group_visible_actions (`id_act`,`id_grp`) VALUES ('.$this->dbh->quote($_GET['id_act']).','.$this->dbh->quote(Viper2::getParam("groupId"),'integer').')';
        }
        if (PEAR::isError($this->dbh->query($query))) {
          v2("Msgbox", "add", _('Nastavení viditelnosti práva se nezdařilo').'. '._('Zkuste, prosím, akci zopakovat').'.');
          return;
        } else {
          v2("Msgbox", "add", _('Viditelnost práva byla nastavena').'.');
          return;
        }
      }
    }
  }

  /**
  * @mask: /group/(?<groupId>\d+)/delete.htm
  * @mask: /group/(?<groupId>\d+)-(?<groupName>[^/]+)/delete.htm
  */
  function actionGroup_Delete($params) {
    if (!empty($_GET['confirmed'])) {
      // potrvzene mazani
      if (!$this->_isSuperAdmin) {
        // chybovou hlasku uz mame v mainfunc
        return;
      }
      $query='DELETE FROM user_groups WHERE id_grp='.$this->dbh->quote(Viper2::getParam("groupId"),'integer');
      if (PEAR::isError($this->dbh->query($query))) {
        v2("Msgbox", "add", _('Nepodařilo se vyřadit uživatele z této skupiny').'.');
        return;
      }
      // to byla ta lehci cast, ted musime jeste upravit ty uzivatele, kteri toto skupinu maji jako vychozi
      $query = 'SELECT id_user FROM users WHERE id_grp='.$this->dbh->quote(Viper2::getParam("groupId"),'integer');
      if (PEAR::isError($Users = $this->dbh->getCol($query))) {
        v2("Msgbox", "add", _('Nepodařilo se vyřadit uživatele z této skupiny').'.');
        return;
      }
      foreach ($Users as $UserId) {
        $User = new flogin_user($this->dbh,$UserId);
        $User->removeUserFromGroup(Viper2::getParam("groupId"));
        if (!$User->save()) {
          v2("Msgbox", "add", _('Nepodařilo se vyřadit všechny uživatele z této skupiny').'. '._('Zkuste, prosím, akci zopakovat').'.');
          return;
        }
      }
      // uzivatele vyrazeni, tak ted muzeme smazat skupinu se vsemi nastavenimi
      if ($this->deleteGroup(Viper2::getParam("groupId"))) {
        v2("Msgbox", "sendOk", _('Skupina byla smazána').'.');
        Viper2::$router->redirectTo("Useradmin::groups");
      } else {
        v2("Msgbox", "add", _('Nepodařilo se smazat skupinu').'. '._('Zkuste, prosím, akci zopakovat').'.');
        return;
      }
    }
  }
  
  function actionSearch($params) {
    if (!empty($_POST)){
      if (!ValidateForm($this->cfgSearchForm, $_POST)) {
        v2("Msgbox", "add", _('Vyplněné hodnoty neodpovídají požadavkům').'.');
        return;
      }
      foreach ($this->cfgSearchForm as $Name=>$Value) {
        if (empty($_POST[$Name])) {
          unset($_SESSION['user_admin']['search_params'][$Name]);
        } else {
          $_SESSION['user_admin']['search_params'][$Name] = $_POST[$Name];
        }
      }
      Viper2::$router->redirectTo("Useradmin::default");
    } elseif (!empty($_GET['clear'])) {
      unset($_SESSION['user_admin']['search_params']);
      Viper2::$router->redirectTo("Useradmin::default");
    }
  }
  
  
  // render

  /**
  * @mask: /
  * @mask: /index.htm
  * @mask: /index_s(?<pageStart>\d+).htm
  */
  function renderDefault($params, &$s) {
    if (!$this->_isAdmin) {
      v2("Msgbox", "put", _('Editovat oprávnění má právo pouze administrátor').'.');
      return;
    }
    $PageLimit = $this->cfgPageCount;
    if (!isset($params["pageStart"]) || $params["pageStart"]<0) {
      $params["pageStart"] = 1;
    } elseif ($params["pageStart"]==0) {
      $PageLimit = 0;
    }
    if (!empty($_SESSION['user_admin']['search_params'])) {
      $SearchParams = $_SESSION['user_admin']['search_params'];
    } else {
      $SearchParams = array();
    }
    $SortBy = null;
    $SortDesc = 0;
    if (!empty($_GET['sort']) && array_key_exists($_GET['sort'], $this->cfgListAttribsDisplay)) {
      $SortBy = $_GET['sort'];
      $SortDesc = !empty($_GET['desc'])?$_GET['desc']*1:0;
    }
    if ($Users = $this->listUsers($PageLimit, $params["pageStart"], $SearchParams, $SortBy, $SortDesc)) {
      $s->assign('Users', $Users['data']);
      $s->assign('ListAttribsDisplay', $this->cfgListAttribsDisplay);
      $s->assign("PAGESTART", $params["pageStart"]);
      $s->assign("PAGELIMIT",$this->cfgPageCount);
      $s->assign("PAGETYPE",'sprava-uzivatelu');
      $s->assign("SEOCOMMENT",'index');
      $s->assign("POCET_ZAZNAMU",$Users['count']);
      if (!empty($SearchParams)) {
        $SeachParamsDescription = array();
        foreach ($SearchParams as $Name => $SearchVal) {
          if (array_key_exists($Name, $this->cfgSearchForm)) {
            $SeachParamsDescription[$Name] = array('description'=>$this->cfgSearchForm[$Name]['label'], 'value'=>$SearchVal);
            if (!empty($this->cfgSearchForm[$Name]['value_func']) && empty($this->cfgSearchForm[$Name]['values'])) {
              $this->loadSelectValues($this->cfgSearchForm[$Name]);
              if (!empty($this->cfgSearchForm[$Name]['values'])) {
                $SeachParamsDescription[$Name]['value']=$this->cfgSearchForm[$Name]['values'][$SearchVal];
              }
            }
          }
        }
        $s->assign('SEARCH_PARAMS', $SeachParamsDescription);
      }
      $s->display($this->getTplPath().'list.tpl');
      $this->useCSS();
    }
  }
  
  
  function renderUser_Add($params, &$s) {
    if (!$this->_isAdmin) {
      v2("Msgbox", "put", _('K přidávání uživatelů nemáte potřebná oprávnění').'.');
      return;
    }
    if (empty($this->fullUserFormStructure)) {
      $this->loadUserEditFormStructure();
    }
    $s->assign('fForm', $this->fullUserFormStructure);
    $s->assign('userAction', "add");
    $s->display($this->getTplPath().'user_edit.tpl');
    $this->useCSS();
  }

  /**
  * @mask: /user/(?<userId>\d+)/edit.htm
  * @mask: /user/(?<userId>\d+)-(?<userName>[^/]+)/edit.htm
  */
  function renderUser_Edit($params, &$s) {
    if (!$this->canEditUserInfo(Viper2::getParam("userId"))) {
      v2("Msgbox", "put", _('K editaci tohoto uživatele nemáte potřebná oprávnění').'.');
      return;
    }
    $User = new flogin_user($this->dbh, Viper2::getParam("userId"));
    if (!$User) {
      v2("Msgbox", "put", _('Nepodařilo se načíst daného uživatele').'.');
      return;
    }
    if (empty($this->fullUserFormStructure)) {
      $this->loadUserEditFormStructure();
    }
    // pozor. Vzhledem k multiskupinovosti se muze stat, ze puvodni hlavni skupina usera byla mimo rozsah editace prihlasenym userem
    $AdminGroups = $this->getUserAdminGroups();
    if (!in_array($User->id_grp, $AdminGroups)) {
      unset($this->fullUserFormStructure['id_grp']);
    }
    foreach ($this->fullUserFormStructure as $VarName=>$Description) {
      if (preg_match('/^[^_]/', $VarName)) {
        // zakladni trida uzivatele
        defPost($_POST[$VarName], $User->$VarName);
      } elseif (preg_match('/^_[^_]/', $VarName)) {
        // pridavna trida uzivatele
        if (!empty($User->val[$VarName])) {
          defPost($_POST[$VarName], $User->val[$VarName]);
        }
      }
    }
//     $UserGroups = Viper2::getVar("userInfo")->getUserGroups();
    $Groups = $this->getValidGroups();
    $s->assign('GroupNames', $Groups);
    /** @todo: overit, ze zobrazime a zpracujeme jen ty skupiny, kterych jsem adminem */
    $ThisUserGroups = $User->getUserGroups();
    $Post = array();
    foreach ($ThisUserGroups as $GroupId) {
      $Post[$GroupId] = 1;
    }
    defPost($_POST['user_groups'], $Post);
    if ($this->_isSuperAdmin) {
      // superadmin. Nacteme jeste seznam vsech grup a umoznime mu nastavit
      if (in_array($this->superadminGrpId, $ThisUserGroups)) {
        $s->assign('UserIsSuperAdmin', true);
      } else {
        $ThisUserAdminGroups = $this->getUserAdminGroups(Viper2::getParam("userId"));
        $Post = array();
        foreach ($ThisUserAdminGroups as $GroupId) {
          $Post[$GroupId] = 1;
        }
        defPost($_POST['user_admin_groups'], $Post);
      }
    }
    // pre_print($this->fullUserFormStructure);
    $s->assign('UserName', $User->name);
    $s->assign('UserId', $User->id_user);
    $s->assign('fForm', $this->fullUserFormStructure);
    $s->assign('userAction', "edit");
    $s->display($this->getTplPath().'user_edit.tpl');
    $this->useCSS();
  }

  /**
  * @mask: /user/(?<userId>\d+)/rights.htm
  * @mask: /user/(?<userId>\d+)-(?<userName>[^/]+)/rights.htm
  */
  function renderUser_Rights($params, &$s) {
    $UserId=Viper2::getParam("userId");
    if (!$this->canEditUserRights($UserId)) {
      v2("Msgbox", "put", _('K editaci tohoto uživatele nemáte potřebná oprávnění').'.');
      return;
    }
    $User= new flogin_user($this->dbh, $UserId);
    $s->assign('UserName', $User->name);
    $s->assign('UserId', $UserId);
    $Rights = $this->loadEditableRightsStatus($UserId);
    if ($Rights!== false) {
      $s->assign('Rights', $Rights);
      $s->display($this->getTplPath().'user_rights_table.tpl');
      $this->useCSS();
    } else {
      v2("Msgbox", "put", _('Nemáte oprávnění pro editaci žádného práva tohoto uživatele').'.');
    }
  }

  /**
  * @mask: /groups/
  * @mask: /groups/index.htm
  * @mask: /groups/index_s(?<pageStart>\d+).htm
  */
  function renderGroups($params, &$s) {
    if (Viper2::getVar("logged")!==TRUE) {
      v2("Msgbox", "put", _('K editaci práv skupin se musíte nejdříve přihlásit').'.');
      return;
    }
    if (!$this->_isSuperAdmin) {
      v2("Msgbox", "put", _('Editovat práva skupin může pouze superadmin').'.');
      return;
    }
    $PageLimit = $this->cfgPageCount;
    if (!isset($params["pageStart"]) || $params["pageStart"]<0) {
      $params["pageStart"] = 1;
    } elseif ($params["pageStart"]==0) {
      $PageLimit = 0;
    }
    $SortBy = null;
    $SortDesc = 0;
    if (!empty($_GET['sort']) && array_key_exists($_GET['sort'], $this->cfgGroupListAttribsDisplay)) {
      $SortBy = $_GET['sort'];
      $SortDesc = !empty($_GET['desc'])?$_GET['desc']*1:0;
    }
    if ($Groups = $this->listGroups($PageLimit, $params["pageStart"], $SortBy, $SortDesc)) {
      // pre_print($Groups);
      $s->assign('Groups', $Groups['data']);
      $s->assign('ListAttribsDisplay', $this->cfgGroupListAttribsDisplay);
      $s->assign("PAGESTART", $params["pageStart"]);
      $s->assign("PAGELIMIT",$this->cfgPageCount);
      $s->assign("PAGETYPE",'sprava-uzivatelu');
      $s->assign("SEOCOMMENT",'skupiny/index');
      $s->assign("POCET_ZAZNAMU",$Groups['count']);

      $s->display($this->getTplPath().'group_list.tpl');
      $this->useCSS();
    }
  }
  
  function renderGroup_Add($params, &$s) {
    if (!$this->_isSuperAdmin) {
      v2("Msgbox", "put", _('K založení skupiny nemáte potřebná oprávnění').'.');
      return;
    }
    $s->assign('fForm', $this->cfgGroupTableStructure);
    $s->assign('groupAction', "add");
    $s->display($this->getTplPath().'group_edit.tpl');
    $this->useCSS();
  }

  /**
  * @mask: /group/(?<groupId>\d+)/edit.htm
  * @mask: /group/(?<groupId>\d+)-(?<groupName>[^/]+)/edit.htm
  */
  function renderGroup_Edit($params, &$s) {
    if (!$this->_isSuperAdmin) {
      v2("Msgbox", "put", _('K editaci skupin nemáte potřebná oprávnění').'.');
      return;
    }
    $query='SELECT * FROM `group_info` WHERE `gid`='.$this->dbh->quote(Viper2::getParam("groupId"));
    if (!PEAR::isError($GroupInfo=$this->dbh->getRow($query))) {
      foreach ($this->cfgGroupTableStructure as $Column=>$Params) {
        defPost($_POST[$Column],$GroupInfo[$Column]);
      }
      $s->assign('fForm', $this->cfgGroupTableStructure);
      $s->assign('GroupName', $GroupInfo['name']);
      $s->assign('GroupId', $GroupInfo['gid']);
      $s->assign('groupAction', "edit");
      $s->display($this->getTplPath().'group_edit.tpl');
    }
  }

  /**
  * @mask: /group/(?<groupId>\d+)/rights.htm
  * @mask: /group/(?<groupId>\d+)-(?<groupName>[^/]+)/rights.htm
  */
  function renderGroup_Rights($params, &$s) {
    if (Viper2::getVar("logged")!==TRUE) {
      v2("Msgbox", "put", _('K editaci práv skupin se musíte nejdříve přihlásit').'.');
      return;
    }
    if (!$this->_isSuperAdmin) {
      v2("Msgbox", "put", _('Editovat práva skupin může pouze superadmin').'.');
      return;
    }

    $UserGroups = Viper2::getVar("userInfo")->getUserGroups();

    $Rights = $this->loadGroupEditableRights(Viper2::getParam("groupId"));
    if ($Rights) {
      $s->assign('GroupName', $this->getGroupName(Viper2::getParam("groupId")));
      $s->assign('GroupId', Viper2::getParam("groupId"));
      $s->assign('Rights', $Rights);
      $s->display($this->getTplPath().'group_rights_table.tpl');
      $this->useCSS();
    }
  }
 
  function renderSearch($params, &$s) {
    if (!$this->_isAdmin) {
      v2("Msgbox", "put", _('Na tuto akci nemáte dostatečná oprávnění').'.');
      return;
    }
    if (!empty($_SESSION['user_admin']['search_params'])) {
      $SearchParams = $_SESSION['user_admin']['search_params'];
      foreach ($this->cfgSearchForm as $Name => $Params) {
        if (!empty($SearchParams[$Name])) {
          defPost($_POST[$Name], $SearchParams[$Name]);
        }
      }
    }
    foreach ($this->cfgSearchForm as $Name=>&$Params) {
      if (!empty($Params['value_func']) && empty($Params['values'])) {
        $this->loadSelectValues($Params);
      }
    }
    unset($Params); // kvuli "bugu" php
    $s->assign('fForm', $this->cfgSearchForm);
    $s->display($this->getTplPath()."seach.tpl");
    $this->useCSS();
  }
  
  function userSaveOrEdit($funcAction) {
    if (!empty($_POST['user_save'])) {
      if (($funcAction=="edit" && !$this->canEditUserInfo(Viper2::getParam("userId")))
        || ($funcAction=="add" && !$this->_isAdmin)
      ) {
        return; // chybovou hlasku osetrime v mainfunc
      }
      if (empty($this->fullUserFormStructure)) {
        $this->loadUserEditFormStructure();
      }
      if (!ValidateForm($this->fullUserFormStructure, $_POST)) {
        v2("Msgbox", "add", _('Opravte prosím chybně zadaná pole').'.');
        return;
      }
      $AdminGroups = $this->getUserAdminGroups();
      if ($funcAction=="add") {
        $User = new flogin_user($this->dbh);
        if (!in_array($_POST['id_grp'], $AdminGroups)) {
          v2("Msgbox", "add", _('Nelze uživatele přiřadit do skupiny, ve které nemáte správcovská práva').'.');
          return;
        }
      } else {
        $User = new flogin_user($this->dbh, Viper2::getParam("userId"));
        // pozor. Vzhledem k multiskupinovosti se muze stat, ze puvodni hlavni skupina usera byla mimo rozsah editace prihlasenym userem
        if (!in_array($User->id_grp, $AdminGroups)) {
          unset($this->fullUserFormStructure['id_grp']);
        }
      }
      foreach ($this->fullUserFormStructure as $VarName=>$Description) {
        if (preg_match('/^[^_]/', $VarName)) {
          // zakladni trida uzivatele
          $User->$VarName = !empty($_POST[$VarName])?$_POST[$VarName]:'';
        } elseif (preg_match('/^_[^_]/', $VarName)) {
          // pridavna trida uzivatele
          $User->val[$VarName] = !empty($_POST[$VarName])?$_POST[$VarName]:'';
        }
      }
      $User->name = $User->fname.' '.$User->lname;
      $ThisUserGroups = $User->getUserGroups();
    
      if (!empty($_POST['user_groups'])) {
        foreach($_POST['user_groups'] as $GroupId=>$Val) {
          if (in_array($GroupId, $AdminGroups)) {
            $User->addUserIntoGroup($GroupId);
          }
        }
      }
      // a ted se jeste musime podivat, jestli nevypnul nejakou skupinu
      foreach ($ThisUserGroups as $GroupId) {
        if (empty($_POST['user_groups'][$GroupId])) {
          if (in_array($GroupId, $AdminGroups)) {
            $User->removeUserFromGroup($GroupId);
          }
        }
      }
      if ($funcAction=="edit" && $this->_isSuperAdmin) {
        if (in_array($this->superadminGrpId, $User->getUserGroups())) {
          // user je superadmin, je tedy spravce vsech skupin
        } else {
          // user neni superadmin, takze nastavime jakych skupin je admin
          $UserAdminGroups = $this->getUserAdminGroups(Viper2::getParam("userId"));
          if (!empty($_POST['user_admin_groups'])) {
            foreach($_POST['user_admin_groups'] as $GroupId=>$Val) {
              if (!in_array($GroupId, $UserAdminGroups)) {
                $this->addGroupAdmin($GroupId, Viper2::getParam("userId"));
              }
            }
            foreach ($UserAdminGroups as $GroupId) {
              if (empty($_POST['user_admin_groups'][$GroupId])) {
                $this->removeGroupAdmin($GroupId, Viper2::getParam("userId"));
              }
            }
          } else {
            // user nema zaskrtnutou zadnou grupu ke spravovani
            $this->removeGroupAdmin(null, Viper2::getParam("userId"));
          }
        }
      }
      if ($User->save()) {
        if ($funcAction=="add") {
          v2("Msgbox", "sendOk", _('Uživatel byl založen. Pokračujte, prosím, nastavením dalších skupin a nastavením práv').'.');
          Viper2::$router->redirectTo("Useradmin::user_edit(userId='".$User->id_user."',userName='".$User->name."')");
        } else {
          v2("Msgbox", "sendOk", _('Data byla úspěšně uložena').'.');
          Viper2::$router->reloadPage();
        }
      } else {
        v2("Msgbox", "add", 'Uložení se nezdařilo.<br />'.$User->status);
      }
    }
  }
  
  function groupSaveOrEdit($funcAction) {
    if (!empty($_POST['user_save'])) {
      if (!$this->_isSuperAdmin) {
        // hlasku uz vypisujeme v mainfunc, takze tady jen return
        return;
      }
      if (!ValidateForm($this->cfgGroupTableStructure, $_POST)) {
        v2("Msgbox", "add", _('Opravte prosím chybně zadaná pole').'.');
        return;
      }
      $QueryParts = array();
      foreach ($this->cfgGroupTableStructure as $Column=>$Params) {
        $QueryParts[] = $this->dbh->quoteIdentifier($Column).'='.$this->dbh->quote($_POST[$Column]);
      }
      if (!empty($QueryParts)) {
        if ($funcAction=="add") {
          $query = 'INSERT INTO group_info SET '.implode(',',$QueryParts);
          if (!PEAR::isError($this->dbh->query($query))) {
            v2('Msgbox', 'sendOk', _('Skupina založena').'.');
            $Id = $this->dbh->lastInsertID();
            Viper2::$router->redirectTo("Useradmin::group_rights(groupId='".$Id."',groupName='".$_POST['name']."')");
          } else {
            v2("Msgbox", "add", _('Uložení se nezdařilo').'. '._('Zkuste, prosím, akci zopakovat').'.');
            return;
          }
        } else {
          $query = 'UPDATE group_info SET '.implode(',',$QueryParts).' WHERE `gid`='.$this->dbh->quote(Viper2::getParam("groupId"),'integer');
          if (!PEAR::isError($this->dbh->query($query))) {
            v2('Msgbox', 'sendOk', _('Data uložena').'.');
            Viper2::$router->reloadPage();
          } else {
            v2("Msgbox", "add", _('Uložení se nezdařilo').'. '._('Zkuste, prosím, akci zopakovat').'.');
            return;
          }
        }
      }
    }
  }
  
  function loadRights() {
    if ($this->isSuperAdmin()) {
      $this->_isSuperAdmin = true;
      if (!empty(Viper2::$smarty)) {
        Viper2::$smarty->assign("USER_ADMIN_IS_SUPERADMIN", true);
      }
    }
    if ($this->isAdmin()) {
      $this->_isAdmin = true;
      if (!empty(Viper2::$smarty)) {
        Viper2::$smarty->assign("USER_ADMIN_IS_ADMIN", true);
      }
    }
    parent::loadRights();
      // var_dump($this->_isSuperAdmin);
  }
  
  
  
  // funkce pro praci s uzivateli
  
  // {{{ loadUserEditFormStructure
  /**
   * funkce nacte a ulozi do cache vsechna editovatelna policka u uzivatele
   *
   * @param @optional $ForceCacheRenew boolean - default false: obnovit data v cache?
   *
   * @return boolean
   */
  protected function loadUserEditFormStructure($ForceCacheRenew=false) {
    $UserForm = $this->cfgUserTableStructure;
    if (empty($this->userClassCache) || $ForceCacheRenew) {
      if ($this->loadUserClassCache()) {
        foreach ($this->userClassCache as $ClassSysName=>$ClassInfo) {
          $UserForm['_'.$ClassSysName] = array(
                'type' => 'text',
                'label'=> $ClassInfo['desc1'],
                'size'    => 20,
                'max'     => 80,
            );
        }
      }
    }
    foreach ($UserForm as $ClassSysName=>&$ClassInfo) {
      if (!empty($ClassInfo['value_func'])
          && empty($ClassInfo['values'])) {
        $this->loadSelectValues($ClassInfo);
      }
    }
    unset($ClassInfo);
    $this->fullUserFormStructure = $UserForm;
    return true;
  }
  // }}} loadUserEditFormStructure

  // {{{ canEditUserInfo
  /**
   * funkce overi prava na editaci informaci uzivatele
   *
   * @param $IdUser - int: id uzivatele ke kteremu chceme zjistit editacni prava
   */
  protected function canEditUserInfo($IdUser) {
    if (Viper2::getVar("logged")!==TRUE) {
      return false;
    }
    // jsem superadmin? Pak nemusim zjistovat vice
    if ($this->_isSuperAdmin) {
      return true;
    }
    // nejsem, tak musim zjistit, jestli je uzivatel ve skupine, kterou adminuji
    $MyAdminGroups = $this->getUserAdminGroups();
    $User = new flogin_user($this->dbh, $IdUser);
    $UserGroups = $User->getUserGroups();
    $Intersect = array_intersect($MyAdminGroups, $UserGroups);
    /** @todo: rozmyslet otazku, jestli nemusim byt adminem vsech skupin, ve kterych uzivatel je */
    if (!empty($Intersect)) {
      return true;
    }
    return false;
  }
  // }}} canEditUserInfo

  // {{{ canEditUserRights
  /**
   * funkce overi prava na editaci prav uzivatele
   *
   * @param $IdUser - int: id uzivatele ke kteremu chceme zjistit editacni prava
   */
  protected function canEditUserRights($IdUser) {
    return $this->canEditUserInfo($IdUser);
  }
  // }}} canEditUserRights

  // {{{ isAdmin
  /**
   * funkce zjisti, zda je dany uzivatel admin nebo alespon admin nejake skupiny
   *
   * @param @optional $IdGrp - int: id skupiny ke ktere chceme zjistit admin prava.
   *     Pokud ponechame null, zjistime, zda uzivatel ma admin prava alespon k 1 skupine
   */
  protected function isAdmin($IdGrp=null) {
    if (Viper2::getVar("logged")!==TRUE) {
      return false;
    }
    $AdminGroups = $this->getUserAdminGroups();
    if (is_null($IdGrp)) {
      return !empty($AdminGroups);
    } else {
      return in_array($IdGrp, $AdminGroups);
    }
    return false;
  }
  // }}} isAdmin

  // {{{ isSuperAdmin
  /**
   * funkce zjisti, zda je prihlaseny uzivatel superadmin
   */
  protected function isSuperAdmin() {
    if (Viper2::getVar("logged")!==TRUE) {
      return false;
    }
    $Groups = Viper2::getVar("userInfo")->getUserGroups();
    if (empty($Groups)) {
      return false;
    }
    if (in_array($this->superadminGrpId, $Groups)) {
      return true;
    }
    return false;
  }
  // }}} isSuperAdmin

  // {{{ loadEditableRightsStatus
  /**
   * funkce nacte nastavitelna prava a jejich aktualni nastaveni pro uzivatele
   *
   * @param $IdUser - int: id uzivatele, pro ktereho chceme nacist prava
   *
   * @return array: indexy pole jsou nazvy systemu,
   *     obsahem jsou pole s indexy id prav
   *         a obsahem podpoli je pole o strukture:
   *            array('description'=> ..., 'group_permission'=>true|false [,'user_permission'=>true|false|null])
   */
  protected function loadEditableRightsStatus($IdUser) {
    // nejdrive zjistime, ktera prava mame moznosti zobrazovat
    $select = 'SELECT a.id, a.desc1, s.name AS SystemName, ua.permission AS User_Permission';
    $from = ' FROM actions AS a LEFT JOIN systems AS s ON (a.id_system=s.id)';
    if ($this->_isSuperAdmin) {
      $from .= ' LEFT JOIN user_actions AS ua ON (ua.id_act=a.id AND ua.id_user='.$this->dbh->quote($IdUser, 'integer').')';
      $group ='';
      $where = '';
    } else {
      $AdminGroups = $this->getUserAdminGroups();
      $from .= ' LEFT JOIN group_visible_actions AS gv ON (a.id=gv.id_act AND gv.id_grp IN ("'.implode('","',$AdminGroups).'"))'.
      ' LEFT JOIN user_actions AS ua ON (ua.id_act=gv.id_act AND ua.id_user='.$this->dbh->quote($IdUser, 'integer').')';
      $group =' GROUP BY a.id';
      $where =' WHERE NOT(gv.id_act IS NULL)';
    }

    $query = $select.$from.$where.$group.' ORDER BY id_system,desc1';
    if (PEAR::isError($Res = $this->dbh->getAll($query))) {
      return false;
    }
    $Prava = array();
    $ZobrazenaPrava = array();
    foreach ($Res as $Row) {
      $Prava[$Row['SystemName']][$Row['id']]['description'] = $Row['desc1'];
      $Prava[$Row['SystemName']][$Row['id']]['user_permission'] = $Row['User_Permission']?true:(is_null($Row['User_Permission'])?null:false);
      $ZobrazenaPrava[] = $Row['id'];
    }

    // ted nacteme vychozi prava dle skupiny, ve kterych je uzivatel zarazen
    $User = new flogin_user($this->dbh, $IdUser);
    $UserGroups = $User->getUserGroups();
    $query = 'SELECT a.id, s.name AS SystemName FROM actions AS a LEFT JOIN systems AS s ON (a.id_system=s.id)'.
      ' JOIN group_actions AS ga ON (a.id=ga.id_act AND ga.id_grp IN ("'.implode('","',$UserGroups).'"))'.
      ' WHERE a.id IN ("'.implode('","',$ZobrazenaPrava).'")'.
      ' GROUP BY a.id';
    if (!PEAR::isError($GroupRights = $this->dbh->getAll($query))) {
      foreach ($GroupRights as $Row) {
        $Prava[$Row['SystemName']][$Row['id']]['group_permission'] = true;
      }
    }
    return $Prava;
  }
  // }}} loadEditableRightsStatus

  // {{{ loadGroupEditableRights
  /**
   * funkce nacte nastavitelna prava a jejich aktualni nastaveni pro skupinu
   *
   * @param $GroupId - int: id skupiny, pro ktereho chceme nacist prava a viditelnost prav
   *
   * @return array: indexy pole jsou nazvy systemu,
   *     obsahem jsou pole s indexy id prav
   *         a obsahem podpoli je pole o strukture:
   *            array('description'=> ..., 'action_visible'=>true|false, 'group_permission'=>true|false)
   */
  protected function loadGroupEditableRights($GroupId) {
    // nejdrive zjistime, jestli jsme opravdu admin
    if (Viper2::getVar("logged")!==TRUE) {
      return false;
    }
    if (!$this->_isSuperAdmin) {
      return false;
    }

    $query = 'SELECT a.id, a.desc1, s.name AS SystemName, NOT(ga.id_act IS NULL) AS Group_Permission, NOT(gv.id_act IS NULL) AS ActionVisible';
    $query .= ' FROM actions AS a LEFT JOIN systems AS s ON (a.id_system=s.id)';
    $query .= ' LEFT JOIN group_actions AS ga ON (ga.id_act=a.id AND ga.id_grp='.$this->dbh->quote($GroupId, 'integer').')';
    $query .= ' LEFT JOIN group_visible_actions AS gv ON (a.id=gv.id_act AND gv.id_grp='.$this->dbh->quote($GroupId, 'integer').')';
    $query .= ' ORDER BY id_system,desc1';
    if (PEAR::isError($Res = $this->dbh->getAll($query))) {
      return false;
    }
    $Prava = array();
    foreach ($Res as $Row) {
      $Prava[$Row['SystemName']][$Row['id']]= array(
        'description' => $Row['desc1'],
        'group_permission' => $Row['Group_Permission'],
        'action_visible' => $Row['ActionVisible']);
    }
    return $Prava;
  }
  // }}} loadGroupEditableRights

  // {{{ getGroupName
  /**
   * function getGroupName
   *
   * funkce nacte jmeno skupiny pro dane id_grp
   *
   * @param $GroupId - int: id skupiny
   *
   * @return string|false - nazev skupiny nebo false pokud se nezdari nazev skupiny nacist (chyba db, skupina neexistuje, ...)
   */
  protected function getGroupName($GroupId) {
    $query = 'SELECT name FROM group_info WHERE gid='.$this->dbh->quote($GroupId);
    if (!PEAR::isError($Name = $this->dbh->getOne($query))) {
      return $Name;
    }
    return false;
  }
  // }}} getGroupName

  // {{{ getUserGroups
  /**
   * funkce zjisti ve kterych skupinach je uzivatel clenem
   *
   * @param $UserId - id uzivatele, ke kteremu chceme zjistit skupiny
   *
   * @return array - klice jsou idcka skupin, data jsou nazvy skupin
   *         false - on fail
   */
  protected function getUserGroups($UserId) {
    if (Viper2::getVar("logged")!==TRUE || Viper2::getVar("loginUid") != $UserId) {
      $User =& Viper2::getVar("userInfo");
    } else {
      $User = new flogin_user($this->dbh, $UseriId);
    }
    if (empty($User)) {
      return false;
    }
    $Groups = $User->getUserGroups();
    if ($Groups === false) {
      return false;
    }
    if (empty($Groups)) {
      return array();
    }
    $query = 'SELECT g.gid, g.name FROM group_info AS g WHERE g.gid IN ("'.implode('","', $Groups).'")';
    if (!PEAR::isError($GroupInfo=$this->dbh->getAll($query))) {
      $Res = array();
      foreach ($GroupInfo as $Row) {
        $Res[$Row['gid']]=$Row['name'];
      }
      return $Res;
    }
    return false;
  }
  // }}} getUserGroups

  // {{{ getUserAdminGroups
  /**
   * funkce nacte a vrati seznam vsech skupin, ve kterych je uzivatel adminem
   *
   * @param @optional $IdUser - id uzivatele, pro ktereho chceme zjistit admin grupy. Pri ponechani null zjisti admin grupy pro aktualne prihlaseneho uzivatele
   *
   * @return array of int - pole idcek skupin, ve kterych dela uzivatel admina
   */
  protected function getUserAdminGroups($UserId=null) {
    if (is_null($UserId)) {
      if (Viper2::getVar("logged")!==TRUE) {
        return false;
      } else {
        $UserId = Viper2::getVar("loginUid");
        $UserGroups = Viper2::getVar("userInfo")->getUserGroups();
      }
    } else {
      if (Viper2::getVar("logged")===TRUE && Viper2::getVar("userInfo")->id_user == $UserId) {
        $UserGroups = Viper2::getVar("userInfo")->getUserGroups();
      } else {
        // zjistuji opravdu informace o nekom jinem, nez jsem ja
        $User = new flogin_user($this->dbh, $UserId);
        $UserGroups = $User->getUserGroups();
      }
    }
    if (in_array($this->superadminGrpId, $UserGroups)) {
      // je superadmin, vratime seznam vsech skupin
      $query = 'SELECT gid FROM group_info';
      if (!PEAR::isError($Groups = $this->dbh->getCol($query))) {
        return $Groups;
      }
    } else {
      $query = 'SELECT `id_grp` FROM `group_admins` WHERE `id_user`='.$this->dbh->quote($UserId,'integer');
      if (!PEAR::isError($Groups = $this->dbh->getCol($query))) {
        return $Groups;
      }
    }
    return false;
  }
  // }}} getUserAdminGroups

  // {{{ addGroupAdmin
  /**
   * nastavi uzivatele jako spravce skupiny
   *
   * @param $GroupId - int: id grupy, do ktere chceme pridat noveho admina
   * @param $UserId - int: id uzivatele, ktery ma byt novy admin grupy $GroupId
   *
   * @return: boolean
   */
  protected function addGroupAdmin($GroupId, $UserId) {
    $query = 'INSERT IGNORE INTO group_admins (`id_user`,`id_grp`) VALUES ('.$this->dbh->quote($UserId,'integer').','.$this->dbh->quote($GroupId, 'integer').')';
    if (!PEAR::isError($this->dbh->query($query))) {
      return true;
    }
    return false;
  }
  // }}} addGroupAdmin

  // {{{ removeGroupAdmin
  /**
   * funkce odstrani uzivatele jako admina skupiny
   *
   * @param @optional $GroupId - id skupiny, ze ktere chceme odstranit admina. Pri nastaveni parametru na null, odstrani uzivatele $UserId ze seznamu vsech skupin
   * @param @optional $UserId - id uzivatele, ktereho chceme odstranit jako admina. Pri nastaveni parametru na null, budou odstaneni vsichni adminstratori skupiny $GroupId
   *
   * @return boolean
   */
  function removeGroupAdmin($GroupId = null, $UserId = null) {
    if (is_null($GroupId) && is_null($UserId)) {
      // z bezpecnostnich duvodu neni mozne smazat vsechny adminy
      return false;
    }
    $query = 'DELETE FROM group_admins WHERE 1';
    if (!is_null($GroupId)) {
      $query .= ' AND id_grp='.$this->dbh->quote($GroupId);
    }
    if (!is_null($UserId)) {
      $query .= ' AND id_user='.$this->dbh->quote($UserId);
    }
    if (!PEAR::isError($this->dbh->query($query))) {
      return true;
    }
    return false;
  }
  // }}} removeGroupAdmin

  // {{{ canEditRight
  /**
   * funkce zjisti, zda prihlaseny uzivatel ma pravo menit toto pravo
   *
   * @param $RightId - int: id prava
   *
   * @return boolean - ma pravo na editaci
   */
  protected function canEditRight($RightId) {
    if (Viper2::getVar("logged")!==TRUE) {
      return false;
    }
    if ($this->_isSuperAdmin) {
      // jsem superadmin, mam pravo na vsechno
      return true;
    }
    // zjistime, na jake skupiny mam pravo editace
    $MyAdminGroups = $this->getUserAdminGroups();
    if (empty($MyAdminGroups)) {
      return false;
    }
    $query = 'SELECT 1 FROM group_visible_actions'.
      ' WHERE id_act='.$this->dbh->quote($RightId,'integer').
          ' AND id_grp IN ("'.implode('","',$MyAdminGroups).'")'.
      ' LIMIT 1';
    if (!PEAR::isError($res=$this->dbh->query($query)) && $res->fetchRow()) {
      return true;
    }
    return false;
  }
  // }}} canEditRight

  // {{{ deleteUser
  /**
   * funkce smaze uzivatele
   */
  protected function deleteUser($IdUser) {
    $DeleteFromTables = array(
      'group_admins'=>'id_user',
      'user_actions'=>'id_user',
      'user_values'=>'id_user',
      'user_groups'=>'id_user',
      'users'=>'id_user'
    );
    foreach ($DeleteFromTables as $Table=>$Column) {
      $query = 'DELETE FROM '.$this->dbh->quoteIdentifier($Table).' WHERE '.$this->dbh->quoteIdentifier($Column).'='.$this->dbh->quote($IdUser,'integer');
      if (PEAR::isError($this->dbh->query($query))) {
        return false;
      }
    }
    return true;
  }
  // }}} deleteUser

  // {{{ deleteGroup
  /**
   * funkce smaze skupinu
   */
  protected function deleteGroup($IdGroup) {
    $DeleteFromTables = array(
      'group_admins'=>'id_grp',
      'group_actions'=>'id_grp',
      'group_values'=>'id_grp',
      'group_visible_actions'=>'id_grp',
      'group_info'=>'gid',
    );
    foreach ($DeleteFromTables as $Table=>$Column) {
      $query = 'DELETE FROM '.$this->dbh->quoteIdentifier($Table).' WHERE '.$this->dbh->quoteIdentifier($Column).'='.$this->dbh->quote($IdGroup,'integer');
      if (PEAR::isError($this->dbh->query($query))) {
        return false;
      }
    }
    return true;
  }
  // }}} deleteUser
  
  // {{{ getUserClassId
  /**
   * funkce vrati ID tridy odpovidajici zadanemu nazvu
   *
   * @param $ClassName - string: nazev classy, pro kterou hledame Id
   * @param $ForceCacheRenew - boolean: nucene obnoveni cache
   *
   * @return int|false on fail
   */
  protected function getUserClassId($ClassName, $ForceCacheRenew = false) {
    if (empty($this->userClassCache) || $ForceCacheRenew) {
      loadUserClassCache();
    }
    if (!empty($this->userClassCache[$ClassName])) {
      return $this->userClassCache[$ClassName];
    }
    return false;
  }
  // }}} getUserClassId

  // {{{ loadUserClassCache
  /**
   * nacte do cache popis trid
   */
  protected function loadUserClassCache() {
    $query = 'SELECT * FROM classes';
    if (!PEAR::isError($Classes = $this->dbh->getAll($query))) {
      foreach($Classes as $ClassInfo) {
        $this->userClassCache[$ClassInfo['varname']] = $ClassInfo;
      }
    }
    return true;
  }
  // }}} loadUserClassCache

  // {{{ listUsers
  /**
   * nacteni uzivatelu dle strany a limitu, pripadne i podle vyhledavani
   *
   * @param $PageLimit - int: limit pro vypis. Pri limitu 0 se neaplikuje limit zadny
   * @param $PageStart - int: cislo strany vypisu. Pri $PageLimit==0 je tento parameter ignorovan
   * @param optional $SearchParams - array: pole indexovane nazvem pole obsahujici hledanou hodnotu
   *                                 pokud chceme hledat dle pridavne tridy, nastavime tuto hodnotu na '_'.<nazev_tridy>
   * @param optional $SortBy - string|array of string: dle jakeho parametru chceme seradit vysledky. Vychozi hodnota 'id_user'
   *                           pokud chceme radit dle pridavne tridy, nastavime tuto hodnotu na '_'.<nazev_tridy>
   * @param optional $SortDesc - boolean|array of boolean: radit sestupne? Vychozi hodnota false
   * @param optional boolean $applyAdminRestriction (default: TRUE) - zobrazit jen ty uzivatele, ke kterym mam pravo editace
   *
   * @return array('count'=><pocet uzivatelu odpovidajicich danemu filteru>, 'data'=><pole s daty o uzivatelich>)
   */
  public function listUsers($PageLimit, $PageStart, $SearchParams=array(), $SortBy=null, $SortDesc=false, $applyAdminRestriction=true) {
    if (is_null($SortBy)) {
      $SortBy = 'id_user';
    }
    if (!is_array($SortBy)) {
      $SortBy = array($SortBy);
    }
    if (!is_array($SortDesc)) {
      $SortDesc = array($sortDesc);
    }
    if (Viper2::getVar("logged")!==TRUE) {
      return false;
    }
    if ($applyAdminRestriction) {
      $UserAdminGroups = array();
      $SuperAdmin = false;
      if ($this->_isSuperAdmin) {
        // superadmin
        $SuperAdmin = true;
      } else {
        $UserAdminGroups = $this->getUserAdminGroups(Viper2::getVar("userInfo")->id_user);
        if (empty($UserAdminGroups)) {
          return false;
        }
      }
    }

    $query = 'SELECT SQL_CALC_FOUND_ROWS u.id_user, u.name, u.lname, u.fname, u.login, u.mail FROM users AS u';
    $join = '';
    $where = ' WHERE 1';
    if (!empty($SearchParams)) {
      foreach ($SearchParams as $Param => $SearchValue) {
        if (array_key_exists($Param, $this->cfgSearchForm)) {
          if (preg_match('/^_([^_].*)$/', $Param, $res)) {
            // jde o tridu, ktera se musi joinovat
            $Param = $res[1];
            $Table = 'cls_'.$Param;
            $join .=' LEFT JOIN user_classes AS '.$Table.' ON (u.id_user='.$Table.'.id_user AND id_cls='.$this->dbh->quote($this->getUserClassId($Param)).')';
          } else {
            $Table = 'u';
            // trida ze zakladni tabulky, neni treba join
            $where .=' AND (u.'.$this->dbh->quoteIdentifier($Param).'';
            if (!empty($this->cfgSearchForm[$Param]['db_type']) && ($this->cfgSearchForm[$Param]['db_type'] == 'int')) {
              $where.= "=".$this->dbh->quote($SearchValue);
            } else {
              $where.= " LIKE ".$this->dbh->quote('%'.$SearchValue.'%');
            }
            if ($Param == 'id_grp') {
              // fuj fuj, ale jinak to nejde
              $where .= ' OR ug.id_grp='.$this->dbh->quote($SearchValue);
              $UserAdminGroups=array($SearchValue);
              $SuperAdmin = false;
            }
            $where .=')';
          }
        }
      }
    }
    $SortByString = '';
    foreach ($SortBy as $key=>$sortCol) {
      if (preg_match('/^_([^_].*)$/', $sortCol, $res)) {
        // jde o serazeni podle pridavneho parametru. Pokud neni uz prirazen ve filtru, tak musime joinout tabulku
        if (!array_key_exists($sortCol, $SearchParams) || // nehledali jsme podle ni
            !array_key_exists($sortCol, $this->cfgSearchForm)  // nebo to bylo podstrcene hledani
            ) {
          $sortCol = $res[1];
          $Table = $this->dbh->quoteIdentifier('cls_'.$sortCol);
          $join .=' LEFT JOIN user_classes AS '.$Table.' ON (u.id_user='.$Table.'.id_user AND id_cls='.$this->dbh->quote($this->getUserClassId($SortBy)).')';
          $SortByString.= (empty($SortByString)?'':', ').$Table.'.val';
          if (!empty($SortDesc[$key])) {
            $SortByString.=' DESC';
          }
        }
      } else {
        $SortByString.= (empty($SortByString)?'':', ').$this->dbh->quoteIdentifier($sortCol);
        if (!empty($SortDesc[$key])) {
          $SortByString.=' DESC';
        }
      }
    }
    // vzdycky prijoinujeme skupiny, protoze se podle nich muze vyhledavat a hlavne ne vsichni uzivatele vidi vsechno
    $join .= ' LEFT JOIN user_groups AS ug ON (u.id_user = ug.id_user'.($SuperAdmin||$applyAdminRestriction?'':' AND ug.id_grp IN ("'.implode('","',$UserAdminGroups).'")').')';
    $query .= $join.$where.($SuperAdmin||$applyAdminRestriction?'':' AND (NOT(ug.id_grp IS NULL) OR u.id_grp IN ("'.implode('","',$UserAdminGroups).'"))');
    $query .=' GROUP BY u.id_user ORDER BY '.$SortByString;

    if ($PageLimit>0) {
      $query .=' LIMIT '.(($PageStart-1)*$PageLimit).','.$PageLimit;
    }
    //echo $query._nl;
    if (!PEAR::isError($Users = $this->dbh->getAll($query))) {
      $Res = array('count'=>null, 'data'=>$Users);
      if(!PEAR::isError($Count=$this->dbh->getOne("SELECT FOUND_ROWS() AS pocet"))){
        $Res['count'] = $Count;
      }
      return $Res;
    }
    return false;
  }
  // }}} listUsers

  // {{{ listGroups
  /**
   * nacteni skupoin dle strany a limitu a sort orderu
   *
   * @param $PageLimit - int: limit pro vypis. Pri limitu 0 se neaplikuje limit zadny
   * @param $PageStart - int: cislo strany vypisu. Pri $PageLimit==0 je tento parameter ignorovan
   * @param optional $SortBy - string: dle jakeho parametru chceme seradit vysledky. Vychozi hodnota 'gid'
   * @param optional $SortDesc - boolean: radit sestupne? Vychozi hodnota false
   *
   * @return array('count'=><pocet skupin>, 'data'=><pole s daty o skupinach>)
   */
  protected function listGroups($PageLimit, $PageStart, $SortBy=null, $SortDesc=false) {
    if (is_null($SortBy)) {
      $SortBy = 'gid';
    }
    if (Viper2::getVar("logged")!==TRUE) {
      return false;
    }
    // var_dump($this->_isSuperAdmin);
    if (!$this->_isSuperAdmin) {
      return false;
    }
    // var_dump(Viper2::getVar("logged"));
    $query = 'SELECT SQL_CALC_FOUND_ROWS gid, name FROM group_info ORDER BY '.$this->dbh->quoteIdentifier($SortBy).($SortDesc?' DESC':'');
    if ($PageLimit>0) {
      $query .=' LIMIT '.(($PageStart-1)*$PageLimit).','.$PageLimit;
    }
    // prettySql($query);
    if (!PEAR::isError($Groups = $this->dbh->getAll($query))) {
      $Res = array('count'=>null, 'data'=>$Groups);
      if(!PEAR::isError($Count=$this->dbh->getOne("SELECT FOUND_ROWS() AS pocet"))){
        $Res['count'] = $Count;
      }
      return $Res;
    }
    return false;
  }
  // }}} listGroups

  // {{{ loadSelectValues
  /**
   *  funkce nacte vsechny povolene hodnoty a prida je do definice formulare
   *
   *  @param $FormInputParams - reference to array: odkaz na pole s definici policka formulare
   */
  protected function loadSelectValues(&$FormInputParams) {

    if (empty($FormInputParams['value_func'])) {
      return;
    }
    if (!is_callable(array(__CLASS__, $FormInputParams['value_func']))) {
      return;
    }
    if (!empty($FormInputParams['value_func_params'])) {
      $Values = call_user_func(array(__CLASS__, $FormInputParams['value_func']), $FormInputParams['value_func_params']);
    } else {
      $Values = call_user_func(array(__CLASS__, $FormInputParams['value_func']));
    }
    if ($Values) {
      $FormInputParams['values'] = $Values;
    }
  }
  // }}} loadSelectValues

  // {{{ getValidGroups
  /**
   * funkce nacte a vrati vsechny platne skupiny uzivatelu
   *
   * @return array: pole indexovane idcky skupin obsahujici jejich nazvy
   */
  protected function getValidGroups() {
    $Groups = $this->getUserAdminGroups(Viper2::getVar("userInfo")->id_user);
    if (!$Groups) {
      return false;
    }
    if (empty($Groups)) {
      return array();
    }
    $query = 'SELECT * FROM group_info WHERE gid IN ("'.implode('","', $Groups).'")';
    if (!PEAR::isError($Groups = $this->dbh->getAll($query))) {
      $Res = array();
      foreach($Groups as $Row) {
        $Res[$Row['gid']] = $Row['name'];
      }
      return $Res;
    }
    return false;
  }
  // }}} getValidGroups

  // {{{ getAllGroups
  /**
   * funkce nacte seznam vsech skupin
   *
   * @return array(<idGroup>=>(String)<name>, ..._)
   */
  public function getAllGroups() {
    $query = 'SELECT gid, name FROM group_info ORDER BY name';
    return $this->dbh->getAssoc($query);
  }
  // }}} getAllGroups
  
  
  /**
  * @mask: /group/(?<groupId>\d+)/delete.htm
  * @mask: /group/(?<groupId>\d+)-(?<groupName>[^/]+)/delete.htm
  */
  function renderGroup_Delete($params, &$s) {
    if (!$this->_isSuperAdmin) {
      v2('Msgbox', 'put', _('Pro smazání skupiny nemáte potřebná oprávnění').'.');
      return;
    }
    $query = 'SELECT name FROM group_info WHERE gid='.$this->dbh->quote($params["groupId"],'integer');
    if (!PEAR::isError($GroupName=$this->dbh->getOne($query))) {
      $s->assign('GroupName', $GroupName);
    }
    $query = 'SELECT SUM(u.id_grp='.$this->dbh->quote($params["groupId"],'integer').') AS PrimaryCount, COUNT(*) AS AllCount'.
      ' FROM users AS u'.
        ' LEFT JOIN user_groups AS ug ON (u.id_user=ug.id_user AND ug.id_grp='.$this->dbh->quote($params["groupId"],'integer').')'.
      'WHERE u.id_grp='.$this->dbh->quote($params["groupId"],'integer').' OR ug.id_grp='.$this->dbh->quote($params["groupId"],'integer');
    if (!PEAR::isError($Row=$this->dbh->getRow($query))) {
      $s->assign('UserCount', $Row['AllCount']);
      $s->assign('PrimaryCount', $Row['PrimaryCount']);
    }
    $s->display($this->getTplPath().'group_delete.tpl');
  }

  

}
?>